package exercises.ex_k;

public class Customer implements Runnable {
    private String name;
    private PostOffice postOffice;

    public Customer(String name, PostOffice postOffice) {
        this.name = name;
        this.postOffice = postOffice;
    }

    public String getName() {
        return name;
    }

    @Override
    public void run() {
        Package pkg;
        while (true) {
            pkg = new Package(this);
            System.out.println("Registering " + pkg + "...");
            postOffice.registerPackage(pkg);
            System.out.println("Registered " + pkg);
            try {
                Thread.sleep((long) (Math.random() * 2000 + 1000));
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
        }
    }
}
