package exercises.ex_k;

import java.util.LinkedList;
import java.util.List;

public class PostOffice {
    public static final int CAPACITY = 5;
    private List<Package> packages = new LinkedList<>();

    public synchronized void registerPackage(Package pkg) {
        while (packages.size() >= CAPACITY) {
            try {
                System.out.println("[PostOffice] Storage is full, waiting");
                wait();
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
        }
        packages.add(pkg);
        System.out.println("[PostOffice] Storage: " + packages.size() + " / " + CAPACITY);
        notifyAll();
    }

    public synchronized Package getNextPackage() {
        while (packages.isEmpty()) {
            try {
                System.out.println("[PostOffice] Storage is empty, waiting");
                wait();
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
        }
        Package pkg = packages.removeFirst();
        System.out.println("[PostOffice] Storage: " + packages.size() + " / " + CAPACITY);
        notifyAll();
        return pkg;
    }
}
