package exercises.ex_p;

import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

public class Partition {
    public static void main(String[] args) {
        Drum bassDrum = new Drum("Bass Drum");
        Drum floortom = new Drum("Floor Tom");
        Drum snareDrum = new Drum("Snare Drum");
        Drum rackTom = new Drum("Rack Tom");
        Drum hiHat = new Drum("Hi-Hat");
        Drum crashCymbal = new Drum("Crash Cymbal");
        Drum rideCymbal = new Drum("Ride Cymbal");
        Drum splashCymbal = new Drum("Splash Cymbal");
        Drum chinaCymbal = new Drum("China Cymbal");
        ScheduledExecutorService executor = Executors.newScheduledThreadPool(9);
        int initialDelay = 1000;
        int quaver = 500; // croche
        int crotchet = 1000; // noire
        int minim = 2000; // blanche
        TimeUnit unit = TimeUnit.MILLISECONDS;

        Drum[] drums = {
            bassDrum, floortom, snareDrum,
            rackTom, hiHat, crashCymbal,
            rideCymbal, splashCymbal, chinaCymbal
        };
        int[] notes = {quaver, crotchet, minim};

        for (int i=0; i < 9; i++) {
            Drum drum = drums[i];
            int rhythm = notes[(int) (Math.random() * 3)];
            executor.scheduleAtFixedRate(drum::play, initialDelay, rhythm, unit);
        }
    }
}
