package exercises.ex_s1;

import java.util.Random;
import java.util.concurrent.ConcurrentHashMap;

public class Cow implements Runnable {
    private String name;
    private ConcurrentHashMap<String, Integer> stalls;
    private final Random random = new Random();

    public Cow(String name, ConcurrentHashMap<String, Integer> stalls) {
        this.name = name;
        this.stalls = stalls;
    }

    @Override
    public void run() {
        while (true) {
            try {
                Thread.sleep((long) (1000L + Math.random() * 5000L));
            } catch (InterruptedException e) {
                break;
            }
            String key = "box" + random.nextInt(1, 4);
            Integer units = stalls.replace(key, 0);
            if (units == null || units == 0) {
                System.out.println(name + " ate nothing");
            } else {
                System.out.println(name + " ate " + units + " units of food from " + key);
            }
        }
    }
}
